<?php
if (!defined('SMF'))
	die('Hacking attempt...');

//Load the function file
	require_once($sourcedir . '/ChatFunctions.php');
// Check if they're allowed here
isAllowedTo('chat_admin');

loadLanguage('Chat');

function ChatSetting()
{
	global $context, $txt, $flashchatsetting;
	$locip = $_SERVER['HTTP_HOST'];
	$loc_client = "http://". $locip .":35555/";
	
	if (isset($_POST['step']) && $_POST['step'] == 2)
	{
		saveSettings();
	}
	
	$flashchatsetting = getConfig();
	loadTemplate('ChatAdmin');
	$context['sub_template'] = $txt['management'];
	$context['page_title'] = $txt['chat'] . ' - ' . $txt['chat_admin_setting'];
	$context['locip'] = $locip;
	$context['valid'] = getValid($flashchatsetting);
}

function saveSettings()
{
    set_time_limit(300);
    switch ($_POST['extendserver']){
        case 0:
            saveLocalSettings();
            break;
        case 1:
            saveHostSettings();
            break;
        default:
           saveFreeSettings();
    }

}
function saveLocalSettings()
{
	global $context, $txt;
	
	$locip = $_SERVER['HTTP_HOST'];
	$chat_Config['extendserver'] = "0";
	$chat_Config['servertype'] = $_POST['servertype'] ? $_POST['servertype'] : 0;
	$client_location = $_POST['client_loc'];
	if($client_location){
		$chat_Config['client_loc'] = $client_location . (substr($client_location,-1,1) != '/' ? '/' : '');
		$serverinfo = getServerHostPortLocal($chat_Config['client_loc']);
		$chat_Config['server_host'] = !empty($_POST['server_host']) ? $_POST['server_host'] : (empty($serverinfo['fc_server_host']) ? $_SERVER['HTTP_HOST'] : $serverinfo['fc_server_host']) ;
		$chat_Config['server_host_s'] = empty($serverinfo['fc_server_host_s']) ? $chat_Config['server_host'] : $serverinfo['fc_server_host_s'];
		$chat_Config['server_host_h'] = empty($serverinfo['fc_server_host_h']) ? $chat_Config['server_host'] : $serverinfo['fc_server_host_h'];
		if(!is_numeric($_POST['server_port']) || strpos($_POST['server_port'] ,".")!==false){
			$chat_Config['server_port'] = empty($serverinfo['fc_server_port']) ? ( $chat_Config['servertype'] == 1 ? '51212' : '51127') : $serverinfo['fc_server_port'] ;
		}else{
			$chat_Config['server_port'] = $_POST['server_port'];
		}
		if(!is_numeric($_POST['server_port_h']) || strpos($_POST['server_port_h'] ,".")!==false){
			$chat_Config['server_port_h'] = empty($serverinfo['fc_server_port_h']) ? ( $chat_Config['servertype'] == 1 ? '31212' : '35555') : $serverinfo['fc_server_port_h'] ;
		}else{
			$chat_Config['server_port_h'] = $_POST['server_port_h'];
		}
		$chat_Config['server_port_s'] = empty($serverinfo['fc_server_port_s']) ? ( $chat_Config['servertype'] == 1 ? '51213' : '51128') : $serverinfo['fc_server_port_s'] ;
		$chat_Config['api_url'] = 'http://' . $chat_Config['server_host'] . ':' . $chat_Config['server_port_h'] . '/';
	}else{
		$chat_Config['server_host'] = $_SERVER['HTTP_HOST'];
		$chat_Config['server_host_h'] = $chat_Config['server_host_s'] = $chat_Config['server_host'];
		if($chat_Config['servertype'] == 1){
			$chat_Config['server_port_h'] = '31212';
			$chat_Config['server_port_s'] = '51213';
			$chat_Config['server_port'] = '51212';
		}else{
			$chat_Config['server_port_h'] = '35555';
			$chat_Config['server_port_s'] = '51128';
			$chat_Config['server_port'] = '51127';
		}
		$chat_Config['api_url'] = 'http://' . $chat_Config['server_host'] . ':' . $chat_Config['server_port_h'] . '/';
		$chat_Config['client_loc'] = $chat_Config['api_url'];
	}
	$s_own_loc = 1;
	$c_own_loc = 1;
	$da = 1;
	if($_POST['server_loc']){
		$c_own_loc = validate_client($chat_Config['client_loc']);
		$da = validate_data_api($chat_Config['api_url'] . 'online.js');
		if($c_own_loc || $da){
			$context['error'] = $txt['http_port_client_location_error'];
			return false;
		}
	}else{
		$c_own_loc = validate_client($chat_Config['client_loc']);
		if($c_own_loc){
			$context['error'] = $txt['http_port_client_location_error'];
			return false;
		}
	}
	$check = validate_client('http://'.parse_url($chat_Config['client_loc'], PHP_URL_HOST).':'.$chat_Config['server_port_h'].'/');
	if($check){
		$context['error'] = $txt['client_location_error'];
		return false;
	}

	$chat_Config['room_list'] = $_POST['room_list'] ? $_POST['room_list'] : 0;
	if($chat_Config['servertype'] == 1){
		$chat_Config['clienttype'] = 0;
	}else{
		$chat_Config['clienttype'] = $_POST['clienttype'] ? $_POST['clienttype'] : 0;
	}
	$chat_Config = checkPublicSettings($chat_Config);

	return save($chat_Config);
}

function saveHostSettings()
{
	global $context, $txt;
	$chat_Config['extendserver'] = "1";
	$chat_Config['client_loc'] = $_POST['client_loc'] ? ($_POST['client_loc'] . (substr($_POST['client_loc'],-1,1) != '/' ? '/' : '')) : '';
	if(empty($chat_Config['client_loc'])){
		//$this->setError('Client Location is Empty!');
		$context['error'] = $txt['client_location_empty_error'];
		return false;
	}				
	$serverinfo = getServerHostPortHost($chat_Config['client_loc']);
	if($serverinfo){					
		$chat_Config['server_host'] = empty($serverinfo['fc_server_host']) ? parse_url($chat_Config['client_loc'], PHP_URL_HOST) : $serverinfo['fc_server_host'];
		$chat_Config['server_host_s'] = empty($serverinfo['fc_server_host_s']) ? '' : $serverinfo['fc_server_host_s'];
		$chat_Config['server_host_h'] = empty($serverinfo['fc_server_host_h']) ? '' : $serverinfo['fc_server_host_h'];
		$chat_Config['server_port'] = empty($serverinfo['fc_server_port']) ? '' : $serverinfo['fc_server_port'];
		$chat_Config['server_port_h'] = empty($serverinfo['fc_server_port_h']) ? '' : $serverinfo['fc_server_port_h'];
		$chat_Config['server_port_s'] = empty($serverinfo['fc_server_port_s']) ? '' : $serverinfo['fc_server_port_s'];
		$chat_Config['api_url'] = 'http://' . $chat_Config['server_host'] . '/';
		$chat_Config['group'] = substr(parse_url($chat_Config['client_loc'], PHP_URL_PATH),1,-1);
		$c_own_loc = validate_client($chat_Config['client_loc']);
		$da = validate_data_api($chat_Config['api_url'] . 'online.js?group=' . $chat_Config['group']);
		if($c_own_loc || $da){
			$context['error'] = $txt['client_location_error'];
			return false;
		}
	}else{
		$context['error'] = $txt['client_location_error'];
		return false;
	}
	
	$chat_Config['room_list'] = $_POST['room_list'] ? $_POST['room_list'] : "0";
	$chat_Config['clienttype'] = $_POST['clienttype'] ? $_POST['clienttype'] : 0;
	$chat_Config = checkPublicSettings($chat_Config);

	return save($chat_Config);
}

function saveFreeSettings()
{
	$chat_Config['extendserver'] = "2";
	$room = !empty($_POST['room']) ? $_POST['room'] : 'Lobby';
	preg_match("/\w+$/", $room,$matches);
	if(strlen($room) != strlen($matches[0])){
		$context['error'] = $txt['room_name_error'];
		return false;
	}	
	$chat_Config['room'] = $room;	
	$chat_Config['client_lang'] = !empty($_POST['client_lang']) ? $_POST['client_lang'] : 'auto';
 	$chat_Config['client_skin'] = !empty($_POST['client_skin']) ? $_POST['client_skin'] : 'default';
	$chat_Config = checkPublicSettings($chat_Config);
	return save($chat_Config);
}

function checkPublicSettings($chat_Config = array())
{
	$chat_Config['user_list'] = !empty($_POST['user_list']) ? $_POST['user_list'] : 0;
	$chat_Config['fullscreen'] = !empty($_POST['fullscreen']) ? $_POST['fullscreen'] : 0;
	if(is_numeric($_POST['client_width']) && $_POST['client_width'] >=780){
		$chat_Config['client_width'] = $_POST['client_width'];
	}else{
		$chat_Config['client_width'] = 780;
	}  
	if(is_numeric($_POST['client_height'] ) && $_POST['client_height'] >=642){
		$chat_Config['client_height'] = $_POST['client_height'];
	}else{
		$chat_Config['client_height'] = 642; 
	}
	return $chat_Config;
}

function getServerHostPortLocal($client_location){
	$content = topcmmRequestRemote::requestRemote($client_location.'htmlchat/config/config.js',1);
	if ($content){
		//server host
		preg_match('/init_host = "([a-zA-Z0-9.]*)";/', $content, $matches);
		if(isset($matches[1])){
			$data['fc_server_host'] = $matches[1];			        	
		}else{
			preg_match('/init_host="([a-zA-Z0-9.]*)";/', $content, $matches);
			if(isset($matches[1])){
				$data['fc_server_host'] = $matches[1];			        	
			}else{
				$data['fc_server_host'] = '';
			}
		}
		//server port
		preg_match('/init_port = ([0-9]*);/', $content, $matches);
		if(isset($matches[1])){
			$data['fc_server_port'] = $matches[1];			        	
		}else{
			$data['fc_server_port'] = '';
		}
		//server host s
		preg_match('/init_host_s = "([a-zA-Z0-9.]*)";/', $content, $matches);
		if(isset($matches[1])){
			$data['fc_server_host_s'] = $matches[1];			        	
		}else{
			preg_match('/init_host_s="([a-zA-Z0-9.]*)";/', $content, $matches);
			if(isset($matches[1])){
				$data['fc_server_host_s'] = $matches[1];			        	
			}else{
				$data['fc_server_host_s'] = '';
			}
		}
		//server port s
		preg_match('/init_port_s = ([0-9]*);/', $content, $matches);
		if(isset($matches[1])){
			$data['fc_server_port_s'] = $matches[1];			        	
		}else{
			$data['fc_server_port_s'] = '';
		}
		//server host h
		preg_match('/init_host_h = "([a-zA-Z0-9.]*)";/', $content, $matches);
		if(isset($matches[1])){
			$data['fc_server_host_h'] = $matches[1];			        	
		}else{
			preg_match('/init_host_h="([a-zA-Z0-9.]*)";/', $content, $matches);
			if(isset($matches[1])){
				$data['fc_server_host_h'] = $matches[1];			        	
			}else{
				$data['fc_server_host_h'] = '';
			}
		}
		//server port h
		preg_match('/init_port_h = ([0-9]*);/', $content, $matches);
		if(isset($matches[1])){
			$data['fc_server_port_h'] = $matches[1];			        	
		}else{
			$data['fc_server_port_h'] = '';
		}
		return $data;
	}else{
		return false;
	}
}

function getServerHostPortHost($client_location){
	$content = topcmmRequestRemote::requestRemote($client_location,1);
	if ($content){
		//server port
		preg_match('/init_port=([0-9]*)/', $content, $matches);
		if(isset($matches[1])){
			$data['fc_server_port'] = $matches[1];			        	
		}
		//server port s
		preg_match('/init_port_s=([0-9]*)/', $content, $matches);
		if(isset($matches[1])){
			$data['fc_server_port_s'] = $matches[1];			        	
		}
		//server port h
		preg_match('/init_port_h=([0-9]*)/', $content, $matches);
		if(isset($matches[1])){
			$data['fc_server_port_h'] = $matches[1];			        	
		}
		//server host
		preg_match('/init_host=([a-zA-Z0-9.]*)/', $content, $matches);
		if(isset($matches[1])){
			$data['fc_server_host'] = $matches[1];			        	
		}
		//server host s
		preg_match('/init_host_s=([a-zA-Z0-9.]*)&/', $content, $matches);
		if(isset($matches[1])){
			$data['fc_server_host_s'] = $matches[1];			        	
		}
		//server host h
		preg_match('/init_host_h=([a-zA-Z0-9.]*)&/', $content, $matches);
		if(isset($matches[1])){
			$data['fc_server_host_h'] = $matches[1];			        	
		}
		return $data;
	}else{
		return false;
	}
}

function getValid($fcSetting){
	$c_server_loc = 1;
	if($fcSetting['server_host']){
		if($fcSetting['server_host'] == $_SERVER['SERVER_NAME']){
			$c_own_loc = validate_client('http://'.$fcSetting['server_host'].':'.$fcSetting['server_port_h'].'/');
			if(!$c_own_loc){
				$c_server_loc = 0;
			}
		}
	}else{
		$c_own_loc = validate_client('http://'.$_SERVER['SERVER_NAME'].':'.$fcSetting['server_port_h'].'/');
		if(!$c_own_loc){
			$c_server_loc = 0;
		}
	}
	return $c_server_loc;
}
?>